# Mako

This is the repo for the Mako language spec. This is a reference parser, and its only job is to parse source to AST or bytecode. Other projects will come along for VM implementations.

```
// C-style comments
/*
    C-style multiline comments
*/

var = 2 // in the global scope
var2 = 4 // also in global scope
echo var + var2 // outputs 6

fn function_name(arg1, arg2)
    var3 = "hi" // implicitly local to this block
    var4 = var + var3 // var4 = "2hi"
    var5 = "hello" + "world"
    return var5
end

var6 = {
    table1 = "foo",
    "table2" = 42,
    240 = anothertable
}
var6[lol] = "foo"
echo var6.table1 // "foo"

if condition then
    // do stuff
elseif condition2 then
    // do stuff
else
    // do stuff
end

var7 = condition ? left : right

for k, v in any_table do
    break
end

for i = 10, 100, 10 do
    break
end

for i = 1, 10 do
    break
end

while true do
    break
end

exit 0
exit "print before exiting 0"
```
